/* Problem URL: https://codeforces.com/gym/104871/problem/H */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

void encode()
{
    map<string, int> var;
    V<string> inv;

    int prev = -1;
    string guy;

    vvi graph;

    V<bool> parentless;

    while (cin >> guy) {
        if (guy.back() == ':') {
            guy.pop_back();

            if (var.find(guy) == var.end()) {
                graph.emplace_back();
                inv.emplace_back(guy);
                var[guy] = var.size();
                parentless.push_back(true);
            }

            prev = var[guy];
            continue;
        }

        if (var.find(guy) == var.end()) {
            graph.emplace_back();
            inv.emplace_back(guy);
            var[guy] = var.size();
            parentless.push_back(false);
        }

        int act = var[guy];
        graph[prev].push_back(act);
        parentless[act] = false;
    }

    int root = 0;
    while (!parentless[root]) {
        root++; 
    }

    string bin;
    vi ans;

    function<void(int)> dfs = [&](int i) {
        // for (auto j : graph[i]) {
        //     ans.push_back(j);
        //     bin.push_back('0');
        // }

        for (auto j : graph[i]) {
            dfs(j);
        }

        for (auto j : graph[i]) {
            bin.push_back('0');
        }

        bin.push_back('1');
        ans.push_back(i);
    };

    dfs(root);

    rep(i, ans.size()) {
        cout << inv[ans[i]] << '\n';
    }
    // reverse(all(bin));
    cout << bin << '\n';
}

void decode()
{
    map<string, int> var;
    V<string> inv;

    string bin;
    while (cin >> bin, !isdigit(bin[0])) {
        var[bin] = var.size();
        inv.emplace_back(bin);
    }

    vvi ans(var.size());

    stack<int> q;
    int i = 0;

    rep(cur, bin.size()) {
        if (bin[cur] == '1') {
            q.push(i);
            i++;
            continue;
        }

        ans[i].push_back(q.top());
        q.pop();
    }

    i = ans.size();
    while (i--) {
        if (ans[i].empty()) {
            continue;
        }

        cout << inv[i] << ": ";
        reverse(all(ans[i]));
        repv(j, ans[i]) {
            cout << inv[j] << ' ';
        }
        cout << '\n';
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    string op;
    cin >> op;

    if (op == "ENCODE") {
        encode();
    } else {
        decode();
    }
}
